//插件名：OP锁
//作者：aabb

//管理员配置文件
var config = new JsonConfigFile("./plugins/OP_locks/config.json")
//超级管理员配置文件
var SA = new JsonConfigFile("./plugins/OP_locks/SA/op.json")

mc.listen("onTick", () => {
    var pla = mc.getOnlinePlayers()
    var oplist = new JsonConfigFile("./plugins/OP_locks/op.json")
    var mode = config.get("静默模式")
    pla.forEach((pl) => {
        const playerName = pl.realName
        if (SA.get(playerName)) {
            if (pl.permLevel != 4) {
                pl.setPermLevel(4)
            }
        }
        if (pl.gameMode == 1) {
            if (!oplist.get(playerName)) {
                pl.setGameMode(0)
                if (!mode) {
                    pl.tell("§d§lOP_locks §7§l>> §c创造模式修改失败！请联系管理员修改权限列表.", 0)
                } 
            }
        }
        if (pl.isOP()) {
            if (!oplist.get(playerName)) {
                pl.setPermLevel(0)
                pl.setGameMode(0)
                if (!mode) {
                    pl.tell("§d§lOP_locks §7§l>> §cOP权限获取失败！请联系管理员修改权限列表.", 0)
                }
            }
        }

    })
})

mc.listen("onJoin", (pl) => {
    var oplist = new JsonConfigFile("./plugins/OP_locks/op.json")
    oplist.init(pl.realName,false)
    if (!pl.isOP()) {
        pl.setGameMode(0)
    }
    if (SA.get(pl.realName)) {
        var oplist = new JsonConfigFile("./plugins/OP_locks/op.json")
        oplist.set(pl.realName, 1)
    }
})

function getPlayerList() {
	let onlinePlayers = mc.getOnlinePlayers();
	let realPlayerList = onlinePlayers.filter(p => !p.isSimulatedPlayer());
	let playerNames = realPlayerList.map(p => p.realName);
	return playerNames;
}

function dis(player) {
    var oplist = new JsonConfigFile("./plugins/OP_locks/SA/op.json")
    if (oplist.get(player.realName)) {
        let fm = mc.newCustomForm()
        let allplayer = getPlayerList()
        fm.setTitle("§dOP_locks权限管理页面")
        fm.addDropdown("§e请选择要管理权限的玩家", allplayer)
        let operate = ["添加管理员身份", "删除管理员身份"]
        fm.addDropdown("§b请选择要执行的操作", operate)
        player.sendForm(fm, function (player, data) {
            dispose(player, data, allplayer);
        });
    } else {
        if (!config.get("静默模式")) {
            player.tell("§d§lOP_locks §7§l>> §r§c你没有权限使用此命令！")
        }
    }
}

function dispose(player, data, allplayer) {
    //[选择目标, 操作0+1-]
    var oplist = new JsonConfigFile("./plugins/OP_locks/op.json")
    if (data == null) {
        player.tell("§d§lOP_locks §7§l>> §r§b表单已放弃.")
    } else {
        var option = data[0]
        var operate = data[1]
        logger.info(option)
        var optionplayername = allplayer[option]
        if (player.realName == optionplayername) {
            player.tell("§d§lOP_locks §7§l>> §r§b你已经是超级管理员了，就不能更改自己的权限了哦~")
            dis(player)
        } else {
            if (operate == 0) {
                oplist.set(optionplayername, 1)
                player.tell("§d§lOP_locks §7§l>> §r§a操作成功！")
            } else {
                oplist.set(optionplayername, 0)
                player.tell("§d§lOP_locks §7§l>> §r§a操作成功！") 
            }
        }
    }
}

mc.listen("onServerStarted", () => {
    if (typeof config.get("静默模式") == 'boolean') {
        logger.info("配置文件加载成功！")
    } else {
        logger.error("配置文件加载失败！请检查是否为布尔值.")
    }
    try {
        var cmd = mc.newCommand("opl", "OP锁GUI", PermType.GameMasters)
        cmd.overload([])
        cmd.setCallback((_cmd, ori, out, _res) => {
            let player = ori.player;
            dis(player);
        });
        cmd.setup()
    } catch(error) {
        logger.error("命令注册失败！" + error)
    }
    colorLog("green", "OP锁加载成功！添加[管理员]请前往plugins/OP_locks/op.json内修改或在游戏中修改，添加[超级管理员]请前往plugins/OP_locks/SA/op.json内修改.")
})